Imports System
Imports EnvDTE
Imports EnvDTE80
Imports System.Diagnostics
Imports Microsoft.VisualBasic
Imports Microsoft.VisualBasic.ControlChars


Public Class PropertyErsteller
    Public Function IsEnabled(ByVal App As DTE2) As Boolean
        'Feststellen, ob es sich beim aktuell in der IDE ausgewhlten Element 
        'um eine VB-Textdatei handelt und absichern, dass eine Klasse ausgewhlt ist


        Try
            Dim sel As TextSelection = CType(App.ActiveDocument.Selection, TextSelection)
            Dim pnt As TextPoint = CType(sel.ActivePoint, TextPoint)
            Dim elem As CodeElement = pnt.CodeElement(vsCMElement.vsCMElementClass)
            Return True

        Catch ex As Exception

        End Try
        Return False
    End Function


    Public Sub PropertyAnlegen(ByVal App As DTE2)
        Dim StartLine As Integer

        If App.ActiveWindow.Type <> EnvDTE.vsWindowType.vsWindowTypeDocument Then
            MsgBox("Diese Aktion kann nur gestartet werden, wenn der Text-Editor aktiv ist.")
        ElseIf Not (App.ActiveDocument.FullName.EndsWith(".vb")) Then

        Else
            Dim sel As TextSelection = CType(App.ActiveDocument.Selection, TextSelection)
            Dim Merkpunkt As EnvDTE.VirtualPoint = sel.ActivePoint
            If Not sel.FindText("End Class") Then
                Exit Sub
            End If
            sel.MoveToPoint(Merkpunkt)


            Dim frm As New frm_Properties
            If frm.ShowDialog() = System.Windows.Forms.DialogResult.OK Then

                sel.FindText("End Class")

                sel.StartOfLine()
                sel.Collapse()
                sel.NewLine()
                sel.LineUp()

                sel.Text() &= frm.Ueberschrift
                sel.Text() &= frm.PropertyString

                If frm.IsReadOnly Then
                    sel.Text() &= frm.ReadString
                ElseIf frm.IsWriteOnly Then
                    sel.Text() &= frm.WriteString
                Else
                    sel.Text() &= frm.ReadString
                    StartLine = sel.TopLine
                    sel.GotoLine(StartLine + 3)
                    sel.Text() &= frm.WriteString
                End If

                sel.FindText("End Class")

                sel.StartOfLine()
                sel.Collapse()
                sel.NewLine()
                sel.LineUp()


            End If

        End If
    End Sub


    Public Sub Constructor_Erstellen(ByVal App As DTE2)
        If App.ActiveWindow.Type <> EnvDTE.vsWindowType.vsWindowTypeDocument Then
            MsgBox("Diese Aktion kann nur gestartet werden, wenn der Text-Editor aktiv ist.")
        ElseIf Not (App.ActiveDocument.FullName.EndsWith(".vb")) Then

        Else
            Dim sel As TextSelection = CType(App.ActiveDocument.Selection, TextSelection)
            If Not sel.FindText("End Class") Then
                Exit Sub
            End If


            Dim BottomPunkt As EnvDTE.VirtualPoint = sel.ActivePoint
            Dim BottomLine As Integer = BottomPunkt.Line

            If Not sel.FindText(" Class ", vsFindOptions.vsFindOptionsBackwards) Then
                Exit Sub
            End If

            Dim TopPunkt As EnvDTE.VirtualPoint = sel.ActivePoint
            Dim TopLine As Integer = TopPunkt.Line

            Dim Variablen As New System.Collections.Generic.Dictionary(Of String, String)

            Dim LastVarName As String = ""
            Dim LastVarAktiv As Boolean = False

            Dim xText As String = ""

            While sel.ActivePoint.Line < BottomLine
                sel.GotoLine(sel.ActivePoint.Line + 1, True)

                If Not sel.Text.Trim = "" Then
                    Dim Teile() As String = sel.Text.Split(" "c)
                    For Each txt As String In Teile
                        xText = txt.Trim
                        If xText <> "" Then
                            If xText.StartsWith("m_") Then
                                LastVarName = xText
                                LastVarAktiv = False
                            ElseIf xText = "As" Then
                                LastVarAktiv = True
                            Else
                                If LastVarName <> "" AndAlso LastVarAktiv Then
                                    If Not Variablen.ContainsKey(LastVarName) Then
                                        Variablen.Add(LastVarName, xText)
                                    End If
                                End If
                                LastVarName = ""
                                LastVarAktiv = False
                            End If
                        End If
                    Next
                End If
            End While


            If Variablen.Count > 0 Then
                Dim NewString As String = ""
                For Each txt As String In Variablen.Keys
                    NewString &= ", " & txt.Substring(2) & " As " & Variablen.Item(txt)
                Next
                NewString = NewString.Substring(2)
                NewString = "Public Sub New(" & NewString & ")"
                sel.FindText("End Class")

                sel.StartOfLine()
                sel.Collapse()
                sel.NewLine()
                sel.LineUp()

                sel.Text() &= NewString
                sel.EndOfLine()
                sel.NewLine()
                For Each txt As String In Variablen.Keys
                    sel.Text() &= txt & " = " & txt.Substring(2)
                    sel.EndOfLine()
                    sel.NewLine()
                Next

                sel.SelectAll()
                sel.SmartFormat()
            End If



        End If
    End Sub

  

End Class
